#include <math.h>
#include <stdlib.h>
#if defined(WIN32)
#  pragma warning(disable: 4996)
#  include "glew.h"
#  include "glut.h"
#  include "glext.h"
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/glut.h>
#endif

/* ĺХåե֥ȤΥ򻲾Ȥݥ󥿤Υǡ */
typedef GLfloat Position[3];
typedef GLuint Edge[2];
typedef GLuint Face[3];

/*
** ΩΤ
*/
GLuint wireCube(const GLuint *buffer)
{
  /* ĺХåե֥ȤˣĺʬΥΰݤ */
  glBindBuffer(GL_ARRAY_BUFFER, buffer[0]);
  glBufferData(GL_ARRAY_BUFFER, sizeof (Position) * 8, NULL, GL_STATIC_DRAW);

  /* ĺХåե֥ȤΥץΥ֤˥ޥåפ */
  Position *position = (Position *)glMapBuffer(GL_ARRAY_BUFFER, GL_WRITE_ONLY);

  /* ĺХåե֥ȤΥ˥ǡ񤭹 */
  position[0][0] = -1.0f;
  position[0][1] = -1.0f;
  position[0][2] = -1.0f;

  position[1][0] =  1.0f;
  position[1][1] = -1.0f;
  position[1][2] = -1.0f;

  position[2][0] =  1.0f;
  position[2][1] = -1.0f;
  position[2][2] =  1.0f;

  position[3][0] = -1.0f;
  position[3][1] = -1.0f;
  position[3][2] =  1.0f;

  position[4][0] = -1.0f;
  position[4][1] =  1.0f;
  position[4][2] = -1.0f;

  position[5][0] =  1.0f;
  position[5][1] =  1.0f;
  position[5][2] = -1.0f;

  position[6][0] =  1.0f;
  position[6][1] =  1.0f;
  position[6][2] =  1.0f;

  position[7][0] = -1.0f;
  position[7][1] =  1.0f;
  position[7][2] =  1.0f;

  /* ĺХåե֥ȤˣʬΥΰݤ */
  glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, buffer[1]);
  glBufferData(GL_ELEMENT_ARRAY_BUFFER, sizeof (Edge) * 12, NULL, GL_STATIC_DRAW);

  /* ĺХåե֥ȤΥץΥ֤˥ޥåפ */
  Edge *edge = (Edge *)glMapBuffer(GL_ELEMENT_ARRAY_BUFFER, GL_WRITE_ONLY);

  /* ĺХåե֥ȤΥ˥ǡ񤭹 */
  edge[ 0][0] = 0;
  edge[ 0][1] = 1;

  edge[ 1][0] = 1;
  edge[ 1][1] = 2;

  edge[ 2][0] = 2;
  edge[ 2][1] = 3;

  edge[ 3][0] = 3;
  edge[ 3][1] = 0;

  edge[ 4][0] = 0;
  edge[ 4][1] = 4;

  edge[ 5][0] = 1;
  edge[ 5][1] = 5;

  edge[ 6][0] = 2;
  edge[ 6][1] = 6;

  edge[ 7][0] = 3;
  edge[ 7][1] = 7;

  edge[ 8][0] = 4;
  edge[ 8][1] = 5;

  edge[ 9][0] = 5;
  edge[ 9][1] = 6;

  edge[10][0] = 6;
  edge[10][1] = 7;

  edge[11][0] = 7;
  edge[11][1] = 4;

  /* ĺХåե֥ȤΥץΥ֤ڤΥ */
  glUnmapBuffer(GL_ELEMENT_ARRAY_BUFFER);

  /* ĺХåե֥Ȥ */
  glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);

  /* ĺХåե֥ȤΥץΥ֤ڤΥ */
  glUnmapBuffer(GL_ARRAY_BUFFER);

  /* ĺХåե֥Ȥ */
  glBindBuffer(GL_ARRAY_BUFFER, 0);

  return 24;
}

/*
** 
*/
GLuint wireSphere(int slices, int stacks, const GLuint *buffer)
{
  GLuint vertices = slices * stacks - slices + 2;
  GLuint edges = slices * stacks * 2 - slices;

  /* ĺХåե֥Ȥͭˤ */
  glBindBuffer(GL_ARRAY_BUFFER, buffer[0]);
  glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, buffer[1]);

  /* ĺХåե֥Ȥ˥ΰݤ */
  glBufferData(GL_ARRAY_BUFFER, sizeof (Position) * vertices, NULL, GL_STATIC_DRAW);
  glBufferData(GL_ELEMENT_ARRAY_BUFFER, sizeof (Edge) * edges, NULL, GL_STATIC_DRAW);

  /* ĺХåե֥ȤΥץΥ֤˥ޥåפ */
  Position *position = (Position *)glMapBuffer(GL_ARRAY_BUFFER, GL_WRITE_ONLY);
  Edge *edge = (Edge *)glMapBuffer(GL_ELEMENT_ARRAY_BUFFER, GL_WRITE_ONLY);

  /* ̶ΰ */
  (*position)[0] =  0.0f;
  (*position)[1] =  1.0f;
  (*position)[2] =  0.0f;
  ++position;

  /* ʬĺΰ */
  for (int j = 1; j < stacks; ++j) {
    float ph = 3.141593f * (float)j / (float)stacks;
    float y = cosf(ph);
    float r = sinf(ph);

    for (int i = 0; i < slices; ++i) {
      float th = 2.0f * 3.141593f * (float)i / (float)slices;
      float x = r * cosf(th);
      float z = r * sinf(th);

      (*position)[0] = x;
      (*position)[1] = y;
      (*position)[2] = z;
      ++position;
    }
  }

  /* ΰ */
  (*position)[0] =  0.0f;
  (*position)[1] = -1.0f;
  (*position)[2] =  0.0f;

  int count = 1;

  /* ̶ */
  for (int i = 1; i <= slices; ++i) {
    (*edge)[0] = 0;
    (*edge)[1] = i;
    ++edge;
  }

  /* ʬ */
  for (int j = 2; j < stacks; ++j) {
    for (int i = 1; i < slices; ++i) {

      /*  */
      (*edge)[0] = count;
      (*edge)[1] = count + 1;
      ++edge;

      /*  */
      (*edge)[0] = count;
      (*edge)[1] = count + slices;
      ++edge;

      ++count;
    }

    /* üαϺüĺ³ */
    (*edge)[0] = count;
    (*edge)[1] = count - slices + 1;
    ++edge;

    /*  */
    (*edge)[0] = count;
    (*edge)[1] = count + slices;
    ++edge;

    ++count;
  }

  /* ǲʤ */
  for (int i = 1; i < slices; ++i) {

    /*  */
    (*edge)[0] = count;
    (*edge)[1] = count + 1;
    ++edge;

    /* ³ */
    (*edge)[0] = count;
    (*edge)[1] = vertices - 1;
    ++edge;

    ++count;
  }

  /* üαϺüĺ³ */
  (*edge)[0] = count;
  (*edge)[1] = count - slices + 1;
  ++edge;

  /* ³ */
  (*edge)[0] = count;
  (*edge)[1] = vertices - 1;

  /* ĺХåե֥ȤΥץΥ֤ڤΥ */
  glUnmapBuffer(GL_ELEMENT_ARRAY_BUFFER);
  glUnmapBuffer(GL_ARRAY_BUFFER);

  /* ĺХåե֥Ȥ */
  glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);
  glBindBuffer(GL_ARRAY_BUFFER, 0);

  return edges * 2;
}

/*
** 򻰳ѷ
*/
GLuint solidSphere(int slices, int stacks, const GLuint *buffer)
{
  GLuint vertices = (slices + 1) * (stacks + 1);
  GLuint faces = slices * stacks * 2;

  /* ĺХåե֥Ȥͭˤ */
  glBindBuffer(GL_ARRAY_BUFFER, buffer[0]);
  glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, buffer[1]);

  /* ĺХåե֥Ȥ˥ΰݤ */
  glBufferData(GL_ARRAY_BUFFER, sizeof (Position) * vertices, NULL, GL_STATIC_DRAW);
  glBufferData(GL_ELEMENT_ARRAY_BUFFER, sizeof (Face) * faces, NULL, GL_STATIC_DRAW);

  /* ĺХåե֥ȤΥץΥ֤˥ޥåפ */
  Position *position = (Position *)glMapBuffer(GL_ARRAY_BUFFER, GL_WRITE_ONLY);
  Face *face = (Face *)glMapBuffer(GL_ELEMENT_ARRAY_BUFFER, GL_WRITE_ONLY);

  /* ĺΰ */
  for (int j = 0; j <= stacks; ++j) {
    float ph = 3.141593f * (float)j / (float)stacks;
    float y = cosf(ph);
    float r = sinf(ph);

    for (int i = 0; i <= slices; ++i) {
      float th = 2.0f * 3.141593f * (float)i / (float)slices;
      float x = r * cosf(th);
      float z = r * sinf(th);

      (*position)[0] = x;
      (*position)[1] = y;
      (*position)[2] = z;
      ++position;
    }
  }

  /* ̤λɸ */
  for (int j = 0; j < stacks; ++j) {
    for (int i = 0; i < slices; ++i) {
      int count = (slices + 1) * j + i;

      /* Ⱦʬ */
      (*face)[0] = count;
      (*face)[1] = count + 1;
      (*face)[2] = count + slices + 2;
      ++face;

      /* Ⱦʬ */
      (*face)[0] = count;
      (*face)[1] = count + slices + 2;
      (*face)[2] = count + slices + 1;
      ++face;
    }
  }

  /* ĺХåե֥ȤΥץΥ֤ڤΥ */
  glUnmapBuffer(GL_ELEMENT_ARRAY_BUFFER);
  glUnmapBuffer(GL_ARRAY_BUFFER);

  /* ĺХåե֥Ȥ */
  glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);
  glBindBuffer(GL_ARRAY_BUFFER, 0);

  return faces * 3;
}
